
#include <lubishev/TextDocument.h>

#include <QPainter>

namespace lubishev {

TextDocument::TextDocument(const QColor &text,
                           const QColor &background,
                           QObject *parent) :
        QTextDocument(parent) {
    setColors(text, background);
}

void TextDocument::drawContents(QPainter *p, const QRectF &rect) {
    // The code is taken from QTextDocument::drawContents.
    // I only made it use custom PaintContext.
    p->save();
    if (rect.isValid()) {
        p->setClipRect(rect);
        mCtx.clip = rect;
    }
    documentLayout()->draw(p, mCtx);
    p->restore();
}

void TextDocument::setColors(const QColor &text, const QColor &background) {
    mCtx.palette.setColor(QPalette::Text, text);
    mCtx.palette.setColor(QPalette::Base, background);
}

} // namespace lubishev

